/*
 * Created on Sep 30, 2004
 *
 */

/**
 * @author DM Auslander
 * Interface functions for use by optimizers
 */
public interface OptFunctions
{
    /**
     * Performance function, created by user to compute
     * performance index for a given parameter set
     * @param x - array of parameter values
     * @return - performance index for parameter set x
     */
    public double performanceFunc(double [] x);

    /**
     * Progress indicator for optimization
     * Can either be used to monitor progress or to control
     * when the search should be terminated
     * @param jBest - best value of performance indes thus far
     * @param jNextBest
     * @param xBest - parameter set corresponding to best index
     * @param xNextBest
     * @return true to continue search; false to terminate
     */
    public boolean optProgress(double jBest, double jNextBest,
            double [] xBest, double [] xNextBest);
}
